/*
 * Copyright (c) 2004 Your Corporation. All Rights Reserved.
 */
package org.skife.derby.groovy;

import groovy.lang.Binding;
import groovy.lang.GroovyShell;
import groovy.sql.Sql;
import org.codehaus.groovy.control.CompilationFailedException;

import java.io.IOException;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;

public class Groovy
{
    public static String evalString(String expression) throws IOException, CompilationFailedException, SQLException
    {
        Binding binding = new Binding();
        final Connection connection = DriverManager.getConnection("jdbc:default:connection");
        Sql sql = new Sql(connection);
        binding.setVariable("sql", sql);
        GroovyShell shell = new GroovyShell(binding);
        Object value = shell.evaluate(expression);
        return String.valueOf(value);
    }

    public static int evalInt(String expression) throws IOException, CompilationFailedException, SQLException
    {
        Binding binding = new Binding();
        final Connection connection = DriverManager.getConnection("jdbc:default:connection");
        Sql sql = new Sql(connection);
        binding.setVariable("sql", sql);
        GroovyShell shell = new GroovyShell(binding);
        Object value = shell.evaluate(expression);
        return  ((Integer)value).intValue();
    }

    public static Timestamp evalTimestamp(String expression)
            throws IOException, CompilationFailedException, SQLException
    {
        Binding binding = new Binding();
        final Connection connection = DriverManager.getConnection("jdbc:default:connection");
        Sql sql = new Sql(connection);
        binding.setVariable("sql", sql);
        GroovyShell shell = new GroovyShell(binding);
        Object value = shell.evaluate(expression);
        if (value instanceof java.util.Date) return new Timestamp(((java.util.Date)value).getTime());
        if (value instanceof Long) return new Timestamp(((Long)value).longValue());
        else return (Timestamp)value;
    }

    public static BigDecimal evalDecimal(String expression)
            throws IOException, CompilationFailedException, SQLException
    {
        Binding binding = new Binding();
        final Connection connection = DriverManager.getConnection("jdbc:default:connection");
        Sql sql = new Sql(connection);
        binding.setVariable("sql", sql);
        GroovyShell shell = new GroovyShell(binding);
        Object value = shell.evaluate(expression);
        if (value instanceof Double) return new BigDecimal(((Double)value).doubleValue());
        else return (BigDecimal)value;
    }

    public static void evalProc(String expression) throws IOException, CompilationFailedException, SQLException
    {
        Binding binding = new Binding();
        final Connection connection = DriverManager.getConnection("jdbc:default:connection");
        Sql sql = new Sql(connection);
        binding.setVariable("sql", sql);
        GroovyShell shell = new GroovyShell(binding);
        shell.evaluate(expression);
    }
}
